package code.model.reader.xmlobjects;

import code.model.structure.*;
import code.model.utils.*;

import java.util.*;

import javax.vecmath.*;

public class XMLBondTemplate
{
        public String id;
		public String blockRuleTemplateIds;
        public String dropRuleTemplateIds;
        public String addRuleTemplateIds;
		
        public XMLBondTemplate()
        {
			blockRuleTemplateIds = "";
        	dropRuleTemplateIds = "";
        	addRuleTemplateIds = "";
        }

        public XMLBondTemplate(BondTemplate bt)
        {
                id = bt.getId();
				
				Vector blockRuleIds = bt.getBlockRuleTemplates();
				for (int i=0; i<blockRuleIds.size(); i++)
				{
					if (i != 0) { blockRuleTemplateIds += ";"; }
					blockRuleTemplateIds += (String)(blockRuleIds.elementAt(i));
				}
				
				Vector dropRuleIds = bt.getDropRuleTemplates();
				for (int i=0; i<dropRuleIds.size(); i++)
				{
					if (i != 0) { dropRuleTemplateIds += ";"; }
					dropRuleTemplateIds += (String)(dropRuleIds.elementAt(i));
				}
				
				Vector addRuleIds = bt.getAddRuleTemplates();
				for (int i=0; i<addRuleIds.size(); i++)
				{
					if (i != 0) { addRuleTemplateIds += ";"; }
					addRuleTemplateIds += (String)(addRuleIds.elementAt(i));
				}
        }

        public BondTemplate getObject()
        {
                BondTemplate bt = new BondTemplate(id);
				
				String[] blockRules = Functions.split(';', blockRuleTemplateIds);
				Vector blockRuleIds = new Vector();
				for (int i=0; i<blockRules.length; i++)
				{
					blockRuleIds.addElement(blockRules[i]);
				}
				bt.setBlockRuleTemplates(blockRuleIds);

				String[] dropRules = Functions.split(';', dropRuleTemplateIds);
				Vector dropRuleIds = new Vector();
				for (int i=0; i<dropRules.length; i++)
				{
					dropRuleIds.addElement(dropRules[i]);
				}
				bt.setDropRuleTemplates(dropRuleIds);

				String[] addRules = Functions.split(';', addRuleTemplateIds);
				Vector addRuleIds = new Vector();
				for (int i=0; i<addRules.length; i++)
				{
					addRuleIds.addElement(addRules[i]);
				}
				bt.setAddRuleTemplates(addRuleIds);

                return bt;
        }
}