package code.model.reader.xmlobjects;

import code.model.structure.*;
import code.model.utils.*;

import java.util.*;

import javax.vecmath.*;

public class XMLRuleTemplate
{
        public String id = "";
        public String action = "";
        public String ifClause = "";
        public String thenClause = "";
        public neuroml.core.List probabilities = new neuroml.core.List();
        public neuroml.core.List times = new neuroml.core.List();
		
        public XMLRuleTemplate()
        {
        }

        public XMLRuleTemplate(RuleTemplate rt)
        {
                id = rt.getId();
                action = rt.getAction();

                String[] conditionArray = rt.getIfClause();
                ifClause = "";
                for (int i=0; i<conditionArray.length; i++)
                {
                        if (i != 0) { ifClause += ";"; }
                        ifClause += conditionArray[i];
                }

                String[] thenArray = rt.getThenClause();
                thenClause = "";
                for (int i=0; i<thenArray.length; i++)
                {
                        if (i != 0) { thenClause += ";"; }
                        thenClause += thenArray[i];
                }

        }

        public RuleTemplate getObject()
        {
                RuleTemplate rt = new RuleTemplate(id);

                String[] ifConds = Functions.split(';', ifClause);
                String[] thenStms = Functions.split(';', thenClause);
                rt.setRule(action, ifConds, thenStms);

                Object[] prArr = probabilities.toArray();
                Object[] tArr = times.toArray();
                int arrLength = (prArr.length > tArr.length) ? tArr.length : prArr.length;
                float[] prFloat = new float[arrLength];
                float[] tFloat = new float[arrLength];

                for(int i=0; i<arrLength; i++)
                {
                        prFloat[i] = ((Float) prArr[i]).floatValue();
                        tFloat[i] = ((Float) tArr[i]).floatValue();
                }
                rt.setProbabilities(prFloat);
                rt.setTimes(tFloat);

                return rt;
        }
}