package code.model.reader.xmlobjects;

import java.util.*;
import javax.vecmath.*;

import code.model.structure.*;
import code.model.utils.*;

public class XMLSimObject
{
        public String id = "";
        public String templateId = "";

        // Particle position
        public float centreOfMassX = 0f;
        public float centreOfMassY = 0f;
        public float centreOfMassZ = 0f;

        // Particle orientation
        public float orientationX = 0f;
        public float orientationY = 1f;
        public float orientationZ = 0f;
        public float orientationAngle = 0f;

        public XMLSimObject()
        {
        }

        public XMLSimObject(SimObject obj)
        {
                id = obj.getId();
                templateId = obj.getTemplateId();

                Vector3f com = obj.getCentreOfMass();
                centreOfMassX = com.x;
                centreOfMassY = com.y;
                centreOfMassZ = com.z;

                AxisAngle4f orient = obj.getOrientation();
                orientationX = orient.x;
                orientationY = orient.y;
                orientationZ = orient.z;
                orientationAngle = orient.angle;
        }

        public SimObject getObject()
        {
                SimObject simObj = new SimObject(id);
                simObj.setTemplateId(templateId);

                simObj.setCentreOfMass(new Vector3f(centreOfMassX, centreOfMassY, centreOfMassZ));

                simObj.setOrientation(new AxisAngle4f(orientationX, orientationY, orientationZ, orientationAngle));

                return simObj;
        }
}
