package code.model.structure;

import java.util.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;

import javax.media.j3d.*;
import javax.vecmath.*;

public class Particle
{
        String id;
        String templateId;
		String parentObjectId;

        Vector3f centreOfMass;
        AxisAngle4f orientation;
        float velocity;
		
		Color3f colour;
		float alpha;
		
		Vector bondIds;
		Vector3f[] bondPoints;
		
		boolean collide;
		
        public Particle(String i)
        {
                id = i;
                templateId = "";
				parentObjectId = "";
                centreOfMass = new Vector3f();
                orientation = new AxisAngle4f();
				
				colour = new Color3f(0f, 0f, 0f);
				alpha = 0f;
				
				bondIds = new Vector();
				bondPoints = new Vector3f[0];
				
				collide = false;
        }
		
		public boolean collide()
		{
			return collide;
		}
		
		public void setCollide(boolean c)
		{
			collide = c;
		}
		
		public void setParentObjectId(String poid)
		{
			parentObjectId = poid;
		}
		
		public String getParentObjectId()
		{
			return parentObjectId;
		}
		
		public void setColour(Color3f col)
		{
			colour = col;
		}
		
		public Color3f getColour()
		{
			return colour;
		}
		
		public void setAlpha(float a)
		{
			alpha = a;
		}
		
		public float getAlpha()
		{
			return alpha;
		}

        public void setTemplateId(String i)
        {
                templateId = i;
        }

        public String getTemplateId()
        {
                return templateId;
        }
		
		public void setBondIds(Vector bi)
		{
			bondIds = bi;
		}
		
		public Vector getBondIds()
		{	
			return bondIds;
		}
		
		public void setBondPoints(Vector3f[] bp)
		{
			bondPoints = bp;
		}
				
		public Vector3f[] getBondPoints()
		{
			return bondPoints;
		}
		
		public Vector3f[] getBondPoints(String bondId)
		{
			Vector3f[] points;
			int index = bondIds.indexOf(bondId);
			if (index == -1)
			{
				points = new Vector3f[0];
			}
			else
			{
				points = new Vector3f[3];
				points[0] = bondPoints[3*index];
				points[1] = bondPoints[3*index + 1];
				points[2] = bondPoints[3*index + 2];
			}
			return points;
		}
		
		public void setBondPoints(String bondId, Vector3f[] points)
		{
			int index = bondIds.indexOf(bondId);
			if (index == -1)
			{
				return;
			}
			else
			{
				bondPoints[3*index] = points[0];
				bondPoints[3*index + 1] = points[1];
				bondPoints[3*index + 2] = points[2];
			}
		}

        public String toString()
        {
				String bonds = "";
				for (int i=0; i<bondIds.size(); i++)
				{
					if (i != 0) {bonds += ", ";}
					bonds += ((String) (bondIds.elementAt(i)));
				}
                return templateId + " (Particle)   Bonds: "+bonds;
        }
		
        public void setCentreOfMass(Vector3f com)
        {
                centreOfMass = com;
        }

        public void translateCentreOfMass(Vector3f t)
        {
                centreOfMass.x += t.x;
                centreOfMass.y += t.y;
                centreOfMass.z += t.z;
        }

        public void setOrientation(AxisAngle4f orient)
        {
                orientation = orient;
        }

        public void setVelocity(float v)
        {
                velocity = v;
        }
		
        public Vector3f getCentreOfMass()
        {
                return centreOfMass;
        }

        public AxisAngle4f getOrientation()
        {
                return orientation;
        }

        public float getVelocity()
        {
                return velocity;
        }
}