package code.model.structure;

import java.util.*;

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.mouse.*;

import javax.media.j3d.*;
import javax.vecmath.*;

public class RuleTemplate
{
        private String id;
        String action;
        String[] ifClause;
        String[] thenClause;

        float[] probabilities;
        float[] times;

        float probability = 0f;
        boolean manual = false;
		
        public RuleTemplate(String i)
        {
                id = i;
				
                action = "";
                ifClause = new String[0];
                thenClause = new String[0];
                probabilities = new float[0];
                times = new float[0];
        }

        public void setProbability(float p)
        {
                probability = p;
        }

        public void setManual(boolean man)
        {
                manual = man;
        }

        public String getId()
        {
                return id;
        }

        public void setId(String i)
        {
                id = i;
        }

        public String getAction()
        {
                return action;
        }

        public String[] getIfClause()
        {
                return ifClause;
        }

        public String[] getThenClause()
        {
                return thenClause;
        }

        public void setRule(String act, String[] ic, String[] tc)
        {
                action = act;
                ifClause = ic;
                thenClause = tc;
        }

        public float getProbabilityAtTime(float time)
        {
                // if the probability is being determined manually, use that stored val
                if (manual)
                {
                        return probability;
                }

                // probability zero if it is before start of sim (should never be called with time -ve)
                if (time < 0f)
                { return 0f; }

                int index = 0;
                for(int i=0; i<times.length; i++)
                {
                        if (times[i] <= time)
                        {
                                index++;
                        }
                        else
                        {
                                break;
                        }
                }

                int i = index;
                if (index == 0)
                {
                        return 1f;
                }
                else if (index == times.length)
                {
                        return probabilities[times.length-1];
                }
                else
                {
                        float tdiff = times[index] - times[index-1];
                        float pdiff = probabilities[index] - probabilities[index-1];
                        float tratio = (time - times[index-1]) / tdiff;
                        return pdiff * tratio + probabilities[index-1];
                }
        }

        public void setProbabilities(float[] p)
        {
                probabilities = p;
        }

        public void setTimes(float[] t)
        {
                times = t;
        }

        public String toString()
        {
                return id + " (RuleTemplate)";
        }
}