package code.model.structure;

import neuroml.core.*;

import java.util.*;
import javax.vecmath.*;

public class SimObjectTemplate
{
        private String id;

        private String[] particleTemplateIds;
        private Vector3f[] particleCentreOfMass;
        private AxisAngle4f[] particleOrientation;

        private String[] subObjectTemplateIds;
        private Vector3f[] subObjectCentreOfMass;
        private AxisAngle4f[] subObjectOrientation;

        public SimObjectTemplate(String i)
        {
                id = i;
                particleTemplateIds = new String[0];
                subObjectTemplateIds = new String[0];
        }

        public String getId()
        {
                return id;
        }

        public void setId(String i)
        {
                id = i;
        }

        public String[] getSubObjectTemplateIds()
        {
                return subObjectTemplateIds;
        }

        public Vector3f[] getSubObjectCentreOfMasses()
        {
                return subObjectCentreOfMass;
        }

        public AxisAngle4f[] getSubObjectOrientations()
        {
                return subObjectOrientation;
        }

        public void setSubObjects(String[] ids, Vector3f[] com, AxisAngle4f[] orient)
        {
                subObjectTemplateIds = ids;
                subObjectCentreOfMass = com;
                subObjectOrientation = orient;
        }

        public String[] getParticleTemplateIds()
        {
                return particleTemplateIds;
        }

        public Vector3f[] getParticleCentreOfMasses()
        {
                return particleCentreOfMass;
        }

        public AxisAngle4f[] getParticleOrientations()
        {
                return particleOrientation;
        }

        public void setParticles(String[] ids, Vector3f[] com, AxisAngle4f[] orient)
        {
                particleTemplateIds = ids;
                particleCentreOfMass = com;
                particleOrientation = orient;
        }

        public String toString()
        {
                return id + " (SimObjectTemplate)";
        }

}